/**
 * Copyright (c) 2005, Paul Tuckey
 * All rights reserved.
 * ====================================================================
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * ====================================================================
 */
package org.tuckey.web.filters.validation;


import java.io.*;

/**
 * @author Paul Tuckey
 * @version $Revision: 9 $ $Date: 2006-09-20 20:36:12 +1200 (Wed, 20 Sep 2006) $
 */
public class DistHelper {

    public static void main(String[] args) throws IOException {
        InputStream is = DistHelper.class.getResourceAsStream("docs/sample-fail.html");
        BufferedReader br = new BufferedReader(new InputStreamReader(is));
        StringBuffer buff = new StringBuffer();
        String input;
        while((input = br.readLine()) != null ) {
            buff.append(input).append('\n');
        }
        String src = buff.toString();
        ValidationHandler vh = new ValidationHandler(src, "/sample-fail.html");
        vh.parse();
        String report = vh.getReportDiv();

        File saveAs = new File("www/sample-fail-report.html");
        System.out.println("about to save to " + saveAs);
        saveAs.createNewFile();
        PrintWriter out = new PrintWriter(new FileOutputStream(saveAs));
        out.println(src);
        out.println(report);
        out.close();

    }
}
