<%@ page import="org.tuckey.web.filters.validation.ValidationHandler"%>
<%@ page import="org.tuckey.web.filters.validation.ValidationFilter"%>
<%@ page import="org.tuckey.web.filters.validation.utils.StringEscapeUtils"%>
<%@ page import="org.tuckey.web.filters.validation.LineIssue"%>
<%@ page import="java.util.List"%>
<%@ page import="org.tuckey.web.filters.validation.utils.StringUtils"%>
<%@ page import="org.tuckey.web.filters.validation.ValidationDoctype"%>
<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.Date"%>
<%--
 @author Paul Tuckey
 @version $Revision: 1 $ $Date: 2006-07-12 08:07:49 +1200 (Wed, 12 Jul 2006) $
--%>
<%!
    public String url;
    public ValidationHandler validationHandler;

    public static String getParserName(ValidationHandler validationHandler) {
        return checkForKnownParser(validationHandler.getParser().getClass().getName());
    }

    public static String checkForKnownParser(String xmlParserFactoryClass) {
        String xmlParser = xmlParserFactoryClass;
        if (xmlParserFactoryClass != null) {
            if (xmlParserFactoryClass.startsWith("org.apache.xerces.")) {
                xmlParser = "Apache Xerces-J";
            } else if (xmlParserFactoryClass.startsWith("org.apache.crimson.")) {
                xmlParser = "Apache Crimson";
            }
        }
        return xmlParser;
    }
%>

<style type="text/css">
    #validationFilterReport {
     position: absolute;
     background-color: white;
     padding: 10px;
     border: 1px solid red;
     top: 10px; left: 10px;
    }
    #validationFilterReportControl {
     position: absolute;
     background-color: white;
     padding: 10px;
     border: 3px solid red;
     top: 5px; left: 200px; width: 300px;
     font-family: Avenir, "Lucida Grande", Verdana, "Bitstream Vera Sans", Arial, Helvetica, sans-serif;
     line-height: 140%; font-size: 12px;
    }

    #validationFilterReport .fat { background-color: #ff6666; }
    #validationFilterReport .err { background-color: #FF9933; }
    #validationFilterReport .war { background-color: #FFFF00; }
    #validationFilterReport h1 { font-size: x-small; font-weight: normal; border-bottom: 1px solid #c0c0c0; letter-spacing: 1px; font-family: Avenir, \"Gill Sans\", Myriad, Arial, \"Bitstream Vera Sans\", Helvetica, sans-serif; }
    #validationFilterReport h2 { font-size: large; letter-spacing: 1px; font-family: Avenir, \"Gill Sans\", Myriad, Arial, \"Bitstream Vera Sans\", Helvetica, sans-serif; }
    #validationFilterReport h3 { font-size: medium; }
    #validationFilterReport h4 { font-size: xx-small; font-weight: normal; border-top: 1px solid #c0c0c0; letter-spacing: 1px; font-family: Avenir, \"Gill Sans\", Myriad, Arial, \"Bitstream Vera Sans\", Helvetica, sans-serif; }
    #validationFilterReport li { line-height: 140%; text-align: left; margin-top: 0; margin-bottom: 1em; font-size: 12px; }
    #validationFilterReport p { line-height: 140%; text-align: left; margin-top: 0; margin-bottom: 1em; font-size: 12px; }
    #validationFilterReport .colInd {
        font-weight: bolder;
        color: #ff0000;
    }
    #validationFilterReport .lin {
        color: #808080;
        background-color: #eee;
        border-right: 1px solid #c0c0c0;
        border-left: 1px solid #c0c0c0;
    }

</style>

<div id="validationFilterReport">

    <h1>ValidationFilter <%= ValidationFilter.VERSION %></h1>
    <h2>XHTML Validation Report for: <%= url %></h2>

    <%
        ValidationDoctype doctype = validationHandler.getDoctype();
        String[] sourceLines = validationHandler.getSourceAsArrayOfLines();
        List errors = validationHandler.getErrors();
    %>
    <p>
    <%
        if (errors.size() == 0) {
            %>This document is valid <%
        } else {
            %>This document is <b class="fat">NOT</b> valid <%
        }
        if (doctype != null) {
            if ("-//W3C//DTD XHTML 1.0 Transitional//EN".equals(doctype.getPublicId())) {
                %><a href="http://www.w3.org/TR/xhtml1/">XHTML 1.0 Transitional</a><%

            } else if ("-//W3C//DTD XHTML 1.0 Strict//EN".equals(doctype.getPublicId())) {
                %><a href="http://www.w3.org/TR/xhtml1/">XHTML 1.0 Strict</a><%

            } else if ("-//W3C//DTD XHTML Basic 1.0//EN".equals(doctype.getPublicId())) {
                %><a href="http://www.w3.org/TR/xhtml-basic/">XHTML 1.0 Basic</a><%

            } else {
                %><%= doctype.getPublicId() %><%
            }
        } else {
            %>No doctype information found<%
        }
    %> markup.
    </p>


    <%
        if (errors.size() == 0) {
            return;
        }
        %><ul><%
        for (int i = 0; i < errors.size(); i++) {
            LineIssue lineIssue = (LineIssue) errors.get(i);
            String goToLine = "";
            if (lineIssue.getLineNumber() > 0) {
                goToLine = " <a href=\"#l" + lineIssue.getLineNumber() + "\">Line " + lineIssue.getLineNumber() + "</a>";
            }
            %><li><%= goToLine %> <span class="<%= lineIssue.getType() %>">
                <%= lineIssue.getTypeTitle() %></span>: (<%= "" + lineIssue.getLineNumber() %>, <%= "" + lineIssue.getColumnNumber() %>) <%= lineIssue.getMessage() %><%
            if (lineIssue.getLineNumber() > 1 && lineIssue.getLineNumber() <= sourceLines.length) {
                String sourceLine = sourceLines[lineIssue.getLineNumber() - 1];
                %><pre><%= StringEscapeUtils.escapeHtml(sourceLine) %>
<%= StringUtils.repeat(" ", lineIssue.getColumnNumber() - 1) %><span class="colInd">^</span></pre></li><%
            }

        }
        %></ul>

    <%
        int padBy = (sourceLines.length + "").length();
    %>
    <h2>Source of: <%= url %></h2>
    <pre>
<%
        for (int i = 0; i < sourceLines.length; i++) {
            int lineNumber = i + 1;
            String sourceLine = StringEscapeUtils.escapeHtml(sourceLines[i]);
            String lineInd = StringUtils.repeat("&nbsp;", (padBy - (lineNumber + "").length())) + lineNumber;

            LineIssue currentLineIssue = null;
            for (int j = 0; j < errors.size(); j++) {
                LineIssue lineIssue = (LineIssue) errors.get(j);
                if (lineIssue.getLineNumber() == lineNumber) {
                    currentLineIssue = lineIssue;
                }
            }
            %><a name="l<%= String.valueOf(lineNumber) %>" /><span class="lin"
                    <%= i == 0 ? " style=\"border-top: 1px solid #c0c0c0;\"" : "" %>
                    <%= i == sourceLines.length - 1 ? " style=\"border-bottom: 1px solid #c0c0c0;\"" : "" %>
            >&nbsp;<%= lineInd %>&nbsp;</span>&nbsp;<%
            if (currentLineIssue != null) {
                String msg = currentLineIssue.getMessage();
                // it's possible the msg is dirty check and fix if it is
                if ( msg.indexOf("\"") != -1 || msg.indexOf("<") != -1 || msg.indexOf(">") != -1) {
                    msg = StringEscapeUtils.escapeHtml(currentLineIssue.getMessage());
                }
                %><span class="<%= currentLineIssue.getType() %>"
                        title="<%= currentLineIssue.getTypeTitle() + ": (" +
                        currentLineIssue.getLineNumber() + ", " +
                        currentLineIssue.getColumnNumber() + ") " +
                        msg %>"><%= sourceLine.trim() %></span><%
            }   else {
                %><%= sourceLine %><%
            }
            %>
<%
        }
    %>
    </pre>


    <br /><h4>
    Generated by <a href="http://tuckey.org/validation/">Validation Filter</a>
    <br />XML Parsed by container <%= getParserName(validationHandler) %>
    <br /><%= new SimpleDateFormat().format(new Date()) %>
    </h4>

</div>

<script type="text/javascript">
    var vfrDisplayed = true;
    function vfrToggle() {
        document.getElementById('validationFilterReport').style.display = vfrDisplayed ? 'none' : '';
        vfrDisplayed = !vfrDisplayed;
    }
    function vfrHide() {
        document.getElementById('validationFilterReport').style.display = 'none';
        document.getElementById('validationFilterReportControl').style.display = 'none';
    }
</script>

<div id="validationFilterReportControl">
    <b>XHTML errors - <a href="#" onclick="vfrToggle();return false;">toggle display</a></b> -
    <a href="#" onclick="vfrHide();return false;">close</a>
</div>
